/*
    XAMIXER - An X11 Audio Mixer
    Copyright (C) 1995 by Jim MacKinnon
    jmack@IN.Edmonton.AB.CA
    jmack@Phys.UAlberta.CA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Form definition file generated with fdesign. */

#include "forms.h"
#include "xamixer.h"
#include "defs.h"

FD_xamixer *create_form_xamixer(void)
{
  FL_OBJECT *obj;
  FD_xamixer *fdui = (FD_xamixer *) fl_calloc(1, sizeof(FD_xamixer));

  fdui->xamixer = fl_bgn_form(FL_NO_BOX, 658, 348);
  obj = fl_add_box(FL_UP_BOX,0,0,658,348,"");
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
  obj = fl_add_text(FL_NORMAL_TEXT,370,296,274,23, \
	"Jim MacKinnon     jmack@IN.Edmonton.AB.CA");
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_RIGHT_BCOL);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,12);
  obj = fl_add_text(FL_NORMAL_TEXT,515,44,65,20,"Left");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_frame(FL_EMBOSSED_FRAME,22,16,619,276,"");
    fl_set_object_boxtype(obj,FL_BORDER_BOX);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,28,17,46,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,275,17,47,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,214,17,46,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,167,17,47,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,121,17,46,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,74,17,47,226,"");

  fdui->level_left = fl_bgn_group();
  L_leds[9] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,226,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,l9ledCB,0);
  L_leds[8] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,216,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,l8ledCB,0);
  L_leds[7] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,206,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,l7ledCB,0);
  L_leds[6] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,196,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,l6ledCB,0);
  L_leds[5] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,186,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,l5ledCB,0);
  L_leds[4] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,176,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,l4ledCB,0);
  L_leds[3] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,166,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,l3ledCB,0);
  L_leds[2] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,156,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,l2ledCB,0);
  L_leds[1] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,146,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,l1ledCB,0);
  L_leds[0] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,550,136,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,l0ledCB,0);
  fl_end_group();


  fdui->level_right = fl_bgn_group();
  R_leds[9] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,226,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,r9ledCB,0);
  R_leds[8] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,216,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,r8ledCB,0);
  R_leds[7] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,206,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,r7ledCB,0);
  R_leds[6] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,196,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,r6ledCB,0);
  R_leds[5] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,186,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,r5ledCB,0);
  R_leds[4] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,176,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_callback(obj,r4ledCB,0);
  R_leds[3] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,166,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,r3ledCB,0);
  R_leds[2] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,156,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,r2ledCB,0);
  R_leds[1] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,146,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,r1ledCB,0);
  R_leds[0] = obj = fl_add_lightbutton(FL_NORMAL_BUTTON,580,136,40,10,"");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_COL1,FL_GREEN);
    fl_set_object_callback(obj,r0ledCB,0);
  fl_end_group();

  obj = fl_add_text(FL_NORMAL_TEXT,390,312,150,30,"Audio Mixer");
    fl_set_object_color(obj,FL_INACTIVE,FL_RIGHT_BCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_HUGE_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  bal = obj = fl_add_slider(FL_HOR_NICE_SLIDER,517,68,120,25,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DARKGOLD);
    fl_set_object_callback(obj,balanceCB,0);
  obj = fl_add_text(FL_NORMAL_TEXT,65,268,65,20,"DSP");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,18,268,65,20,"CD");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,268,268,65,20,"Record");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,204,268,65,20,"MIC");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,158,268,65,20,"LINE");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,111,268,65,20,"FM");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,385,17,47,226,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,337,17,48,226,"");
  obj = fl_add_text(FL_NORMAL_TEXT,376,268,65,20,"Treble");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,329,268,65,20,"Bass");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,450,17,62,226,"");
  obj = fl_add_text(FL_NORMAL_TEXT,449,269,65,20,"MASTER");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,543,99,65,20,"BALANCE");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,575,44,65,20,"Right");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
  obj = fl_add_frame(FL_EMBOSSED_FRAME,330,18,2,273,"");
  obj = fl_add_frame(FL_EMBOSSED_FRAME,440,19,2,271,"");

/* CDROM lock volume */
  fdui->cd_locker = fl_bgn_group();
  cd.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,28,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_YELLOW);
    fl_set_object_callback(obj,cdlockCB,0);
  cd.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,29,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_YELLOW);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,cdleftvolCB,0);
  cd.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,50,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_YELLOW);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,cdrightvolCB,0);
  fl_end_group();

/* DSP  lock volume */
  fdui->dsp_locker = fl_bgn_group();
  dsp.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,75,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_GREEN);
    fl_set_object_callback(obj,lockdspCB,0);
  dsp.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,76,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_GREEN);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,dspleftvolCB,0);
  dsp.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,97,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_GREEN);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,dsprightvolCB,0);
  fl_end_group();

/* FM   lock volume */
  fdui->fm_locker = fl_bgn_group();
  fm.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,122,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_SLATEBLUE);
    fl_set_object_callback(obj,lockfmCB,0);
  fm.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,122,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_SLATEBLUE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,fmleftvolCB,0);
  fm.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,143,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_SLATEBLUE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,fmrightvolCB,0);
  fl_end_group();

/* LINE  lock volume */
  fdui->line_locker = fl_bgn_group();
  line.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,168,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_WHITE);
    fl_set_object_callback(obj,locklineCB,0);
  line.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,169,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_WHITE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,lineleftvolCB,0);
  line.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,190,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_WHITE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,linerightvolCB,0);
  fl_end_group();

/* MIC   lock volume */
  fdui->mic_locker = fl_bgn_group();
  mic.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,215,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_MAGENTA);
    fl_set_object_callback(obj,lockmicCB,0);
  mic.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,215,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_MAGENTA);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,micleftvolCB,0);
  mic.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,236,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_MAGENTA);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,micrightvolCB,0);
  fl_end_group();

/* RECORD lock volume */
  fdui->rec_locker = fl_bgn_group();
  record.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,276,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_RED);
    fl_set_object_callback(obj,lockrecordCB,0);
  record.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,277,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_RED);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,recordleftvolCB,0);
  record.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,298,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_RED);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,recordrightvolCB,0);
  fl_end_group();

/* BASS  lock volume */
  fdui->bass_locker = fl_bgn_group();
  bass.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,338,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_RIGHT_BCOL);
    fl_set_object_callback(obj,lockbassCB,0);
  bass.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,340,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,bassleftvolCB,0);
  bass.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,361,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,bassrightvolCB,0);
  fl_end_group();

/* TREBLE lock volume */
  fdui->treble_locker = fl_bgn_group();
  treble.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,386,243,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_RIGHT_BCOL);
    fl_set_object_callback(obj,locktrebleCB,0);
  treble.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,387,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_MCOL);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,trebleleftvolCB,0);
  treble.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,408,114,23,125,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_MCOL);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,treblerightvolCB,0);
  fl_end_group();

/* MASTER lock volume */
  fdui->master_locker = fl_bgn_group();
  master.toggle.lock.obj = obj = fl_add_lightbutton(FL_PUSH_BUTTON,459,244,45,20,"lock");
    fl_set_object_color(obj,FL_CYAN,FL_INACTIVE);
    fl_set_object_lcol(obj,FL_BLUE);
    fl_set_object_callback(obj,lockmasterCB,0);
  master.obj.left = obj = fl_add_slider(FL_VERT_NICE_SLIDER,451,114,31,126,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_MCOL,FL_BLUE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,masterleftvolCB,0);
  master.obj.right = obj = fl_add_slider(FL_VERT_NICE_SLIDER,481,114,31,126,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_MCOL,FL_BLUE);
    fl_set_object_lcol(obj,FL_INACTIVE);
    fl_set_object_callback(obj,masterrightvolCB,0);
  fl_end_group();

  obj = fl_add_frame(FL_EMBOSSED_FRAME,267,18,2,273,"");

/* BASS toggles */
  fdui->bass_toggles = fl_bgn_group();
  bass.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,339,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,bassnormCB,0);
  bass.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,339,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,bassmaxCB,0);
  bass.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,339,34,46,17,"min");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,bassminCB,0);
  fl_end_group();

/* TREBLE toggles */
  fdui->treble_toggles = fl_bgn_group();
  treble.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,385,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,treblenormCB,0);
  treble.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,385,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,treblemaxCB,0);
  treble.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,385,34,46,17,"min");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,trebleminCB,0);
  fl_end_group();

/* CD toggles */
  fdui->cd_toggles = fl_bgn_group();
  cd.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,30,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,cdnormCB,0);
  cd.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,30,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,cdmaxCB,0);
  cd.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,30,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,cdmuteCB,0);
  fl_end_group();

/* DSP toggles */
  fdui->dsp_toggles = fl_bgn_group();
  dsp.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,76,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,dspnormCB,0);
  dsp.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,76,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,dspmaxCB,0);
  dsp.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,76,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,dspmuteCB,0);
  fl_end_group();

/* FM toggles */
  fdui->fm_toggles = fl_bgn_group();
  fm.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,122,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,fmnormCB,0);
  fm.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,122,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,fmmaxCB,0);
  fm.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,122,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,fmmuteCB,0);
  fl_end_group();

/* LINE toggles */
  fdui->line_toggles = fl_bgn_group();
  line.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,168,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,linenormCB,0);
  line.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,168,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,linemaxCB,0);
  line.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,168,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,linemuteCB,0);
  fl_end_group();

/* MIC toggles */
  fdui->mic_toggles = fl_bgn_group();
  mic.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,214,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,micnormCB,0);
  mic.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,214,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,micmaxCB,0);
  mic.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,214,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,micmuteCB,0);
  fl_end_group();

/* RECORD toggles */
  fdui->record_toggles = fl_bgn_group();
  record.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,275,68,46,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,recordnormCB,0);
  record.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,275,51,46,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,recordmaxCB,0);
  record.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,275,34,46,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,recordmuteCB,0);
  fl_end_group();

/* Input REC channel toggles */
  fdui->rec_toggles = fl_bgn_group();
  cd.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,30,17,46,17,"rec");
    fl_set_object_color(obj,FL_INACTIVE,FL_MAGENTA);
    fl_set_object_callback(obj,cdrecCB,0);
  dsp.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,76,17,46,17,"rec");
    fl_set_object_color(obj,FL_INACTIVE,FL_MAGENTA);
    fl_set_object_callback(obj,dsprecCB,0);
  fm.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,122,17,46,17,"rec");
    fl_set_object_color(obj,FL_INACTIVE,FL_MAGENTA);
    fl_set_object_callback(obj,fmrecCB,0);
  line.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,168,17,46,17,"rec");
    fl_set_object_color(obj,FL_INACTIVE,FL_MAGENTA);
    fl_set_object_callback(obj,linerecCB,0);
  mic.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,214,17,46,17,"rec");
    fl_set_object_color(obj,FL_INACTIVE,FL_MAGENTA);
    fl_set_object_callback(obj,micrecCB,0);
  record.toggle.rec.obj = obj = fl_add_button(FL_RADIO_BUTTON,275,17,46,17,"on/off");
    fl_set_object_color(obj,FL_RED,FL_INDIANRED);
    fl_set_object_callback(obj,recordonoffCB,0);
  fl_end_group();

/* MASTER toggles */
  fdui->master_toggles = fl_bgn_group();
  master.toggle.Norm.obj = obj = fl_add_button(FL_RADIO_BUTTON,451,68,61,26,"Norm");
    fl_set_object_color(obj,FL_INACTIVE,FL_GREEN);
    fl_set_object_callback(obj,masternormCB,0);
  master.toggle.max.obj = obj = fl_add_button(FL_RADIO_BUTTON,451,51,61,17,"max");
    fl_set_object_color(obj,FL_MCOL,FL_RED);
    fl_set_object_callback(obj,mastermaxCB,0);
  master.toggle.mute.obj = obj = fl_add_button(FL_RADIO_BUTTON,451,34,61,17,"mute");
    fl_set_object_color(obj,FL_MCOL,FL_SLATEBLUE);
    fl_set_object_callback(obj,mastermuteCB,0);
  fl_end_group();

/* Solo toggles */
  fdui->solo_toggles = fl_bgn_group();
  cd.toggle.solo.obj = obj = fl_add_button(FL_INOUT_BUTTON,30,94,46,17,"Solo");
    fl_set_object_color(obj,FL_COL1,FL_CYAN);
    fl_set_object_callback(obj,cdsoloCB,0);
  dsp.toggle.solo.obj = obj = fl_add_button(FL_INOUT_BUTTON,76,94,46,17,"Solo");
    fl_set_object_color(obj,FL_COL1,FL_CYAN);
    fl_set_object_callback(obj,dspsoloCB,0);
  fm.toggle.solo.obj = obj = fl_add_button(FL_INOUT_BUTTON,122,94,46,17,"Solo");
    fl_set_object_color(obj,FL_COL1,FL_CYAN);
    fl_set_object_callback(obj,fmsoloCB,0);
  line.toggle.solo.obj = obj = fl_add_button(FL_INOUT_BUTTON,168,94,46,17,"Solo");
    fl_set_object_color(obj,FL_COL1,FL_CYAN);
    fl_set_object_callback(obj,linesoloCB,0);
  mic.toggle.solo.obj = obj = fl_add_button(FL_INOUT_BUTTON,214,94,46,17,"Solo");
    fl_set_object_color(obj,FL_COL1,FL_CYAN);
    fl_set_object_callback(obj,micsoloCB,0);
  fl_end_group();

  center = obj = fl_add_button(FL_INOUT_BUTTON,568,40,18,20,"Center");
    fl_set_object_color(obj,FL_COL1,FL_DARKGOLD);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_BOTTOM);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE+FL_ENGRAVED_STYLE);
    fl_set_object_callback(obj,balcenterCB,0);
  obj = fl_add_text(FL_NORMAL_TEXT,532,312,85,23,"Version 1.00-c");
    fl_set_object_color(obj,FL_INACTIVE,FL_MCOL);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESBOLDITALIC_STYLE);
  obj = fl_add_button(FL_NORMAL_BUTTON,22,307,61,21,"Quit");
    fl_set_object_color(obj,FL_BOTTOM_BCOL,FL_COL1);
    fl_set_object_lcol(obj,FL_DARKGOLD);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESITALIC_STYLE);
    fl_set_object_callback(obj,quitCB,0);
  fl_end_form();

  return fdui;
}
/*---------------------------------------*/

