/*
    XAMIXER - An X11 Audio Mixer
    Copyright (C) 1995 by Jim MacKinnon
    jmack@IN.Edmonton.AB.CA
    jmack@Phys.UAlberta.CA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Header file generated with fdesign. */

#ifndef FD_xamixer_h_
#define FD_xamixer_h_

/**** Callback routines ****/

extern void l9ledCB(FL_OBJECT *, long);
extern void l8ledCB(FL_OBJECT *, long);
extern void l7ledCB(FL_OBJECT *, long);
extern void l6ledCB(FL_OBJECT *, long);
extern void l5ledCB(FL_OBJECT *, long);
extern void l4ledCB(FL_OBJECT *, long);
extern void l3ledCB(FL_OBJECT *, long);
extern void l2ledCB(FL_OBJECT *, long);
extern void l1ledCB(FL_OBJECT *, long);
extern void l0ledCB(FL_OBJECT *, long);
extern void r9ledCB(FL_OBJECT *, long);
extern void r8ledCB(FL_OBJECT *, long);
extern void r7ledCB(FL_OBJECT *, long);
extern void r6ledCB(FL_OBJECT *, long);
extern void r5ledCB(FL_OBJECT *, long);
extern void r4ledCB(FL_OBJECT *, long);
extern void r3ledCB(FL_OBJECT *, long);
extern void r2ledCB(FL_OBJECT *, long);
extern void r1ledCB(FL_OBJECT *, long);
extern void r0ledCB(FL_OBJECT *, long);
extern void balanceCB(FL_OBJECT *, long);
extern void cdlockCB(FL_OBJECT *, long);
extern void cdleftvolCB(FL_OBJECT *, long);
extern void cdrightvolCB(FL_OBJECT *, long);
extern void lockdspCB(FL_OBJECT *, long);
extern void dspleftvolCB(FL_OBJECT *, long);
extern void dsprightvolCB(FL_OBJECT *, long);
extern void lockfmCB(FL_OBJECT *, long);
extern void fmleftvolCB(FL_OBJECT *, long);
extern void fmrightvolCB(FL_OBJECT *, long);
extern void locklineCB(FL_OBJECT *, long);
extern void lineleftvolCB(FL_OBJECT *, long);
extern void linerightvolCB(FL_OBJECT *, long);
extern void lockmicCB(FL_OBJECT *, long);
extern void micleftvolCB(FL_OBJECT *, long);
extern void micrightvolCB(FL_OBJECT *, long);
extern void lockrecordCB(FL_OBJECT *, long);
extern void recordleftvolCB(FL_OBJECT *, long);
extern void recordrightvolCB(FL_OBJECT *, long);
extern void lockbassCB(FL_OBJECT *, long);
extern void bassleftvolCB(FL_OBJECT *, long);
extern void bassrightvolCB(FL_OBJECT *, long);
extern void locktrebleCB(FL_OBJECT *, long);
extern void trebleleftvolCB(FL_OBJECT *, long);
extern void treblerightvolCB(FL_OBJECT *, long);
extern void lockmasterCB(FL_OBJECT *, long);
extern void masterleftvolCB(FL_OBJECT *, long);
extern void masterrightvolCB(FL_OBJECT *, long);
extern void bassnormCB(FL_OBJECT *, long);
extern void bassmaxCB(FL_OBJECT *, long);
extern void bassminCB(FL_OBJECT *, long);
extern void treblenormCB(FL_OBJECT *, long);
extern void treblemaxCB(FL_OBJECT *, long);
extern void trebleminCB(FL_OBJECT *, long);
extern void cdnormCB(FL_OBJECT *, long);
extern void cdmaxCB(FL_OBJECT *, long);
extern void cdmuteCB(FL_OBJECT *, long);
extern void dspnormCB(FL_OBJECT *, long);
extern void dspmaxCB(FL_OBJECT *, long);
extern void dspmuteCB(FL_OBJECT *, long);
extern void fmnormCB(FL_OBJECT *, long);
extern void fmmaxCB(FL_OBJECT *, long);
extern void fmmuteCB(FL_OBJECT *, long);
extern void linenormCB(FL_OBJECT *, long);
extern void linemaxCB(FL_OBJECT *, long);
extern void linemuteCB(FL_OBJECT *, long);
extern void micnormCB(FL_OBJECT *, long);
extern void micmaxCB(FL_OBJECT *, long);
extern void micmuteCB(FL_OBJECT *, long);
extern void recordnormCB(FL_OBJECT *, long);
extern void recordmaxCB(FL_OBJECT *, long);
extern void recordmuteCB(FL_OBJECT *, long);
extern void cdrecCB(FL_OBJECT *, long);
extern void dsprecCB(FL_OBJECT *, long);
extern void fmrecCB(FL_OBJECT *, long);
extern void linerecCB(FL_OBJECT *, long);
extern void micrecCB(FL_OBJECT *, long);
extern void recordonoffCB(FL_OBJECT *, long);
extern void masternormCB(FL_OBJECT *, long);
extern void mastermaxCB(FL_OBJECT *, long);
extern void mastermuteCB(FL_OBJECT *, long);
extern void cdsoloCB(FL_OBJECT *, long);
extern void dspsoloCB(FL_OBJECT *, long);
extern void fmsoloCB(FL_OBJECT *, long);
extern void linesoloCB(FL_OBJECT *, long);
extern void micsoloCB(FL_OBJECT *, long);
extern void balcenterCB(FL_OBJECT *, long);
extern void quitCB(FL_OBJECT *, long);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *xamixer;
	FL_OBJECT *level_left;
	FL_OBJECT *level_right;
	FL_OBJECT *cd_locker;
	FL_OBJECT *dsp_locker;
	FL_OBJECT *fm_locker;
	FL_OBJECT *line_locker;
	FL_OBJECT *mic_locker;
	FL_OBJECT *rec_locker;
	FL_OBJECT *bass_locker;
	FL_OBJECT *treble_locker;
	FL_OBJECT *master_locker;
	FL_OBJECT *bass_toggles;
	FL_OBJECT *treble_toggles;
	FL_OBJECT *cd_toggles;
	FL_OBJECT *dsp_toggles;
	FL_OBJECT *fm_toggles;
	FL_OBJECT *line_toggles;
	FL_OBJECT *mic_toggles;
	FL_OBJECT *record_toggles;
	FL_OBJECT *rec_toggles;
	FL_OBJECT *master_toggles;
	FL_OBJECT *solo_toggles;
	void *vdata;
	long ldata;
} FD_xamixer;

extern FD_xamixer * create_form_xamixer(void);

#endif /* FD_xamixer_h_ */

/*---------------------------------------*/

