/*
    XAMIXER - An X11 Audio Mixer
    Copyright (C) 1995 by Jim MacKinnon
    jmack@IN.Edmonton.AB.CA
    jmack@Phys.UAlberta.CA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <sys/types.h>
#include <fcntl.h>
#include <linux/cdrom.h>
#include <linux/errno.h>


#include "forms.h"
#include "xamixer.h"
#include "defs.h"

/* callbacks for form xamixer */


/* LED displays not implemented yet */

void l9ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l8ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l7ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l6ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l5ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l4ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l3ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l2ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l1ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void l0ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r9ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r8ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r7ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r6ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r5ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r4ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r3ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r2ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r1ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void r0ledCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

/* rest of the objects */

void balcenterCB(FL_OBJECT *ob, long data)
{
    /* button routine to center the balance */
    static double               vol,tmpl,tmpr, sbal;

        tmpl = 1.0 - fl_get_slider_value(master.obj.left);
        tmpr = 1.0 - fl_get_slider_value(master.obj.right);
	sbal = (tmpl+tmpr)/2;
	vol = sbal*SOUND_FULL_SCALE;

        master.volume.left = master.volume.right = (u_char)vol;
	Sbalance.left = Sbalance.right = 0.5;

        fl_set_slider_value(master.obj.left,1.0 - sbal);
        fl_set_slider_value(master.obj.right,1.0 - sbal);

        fl_set_slider_value(bal,0.5);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);

}

void cdlockCB(FL_OBJECT *ob, long data)
{

}

void cdleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	cd.volume.left = (u_char)vol;
	sav_cd.left = tmp;

	if(!fl_get_button(cd.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	cd.volume.right =  cd.volume.left;
		fl_set_slider_value(cd.obj.right,1.0 - tmp);	
		sav_cd.right = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);
    }
    old_vol = vol;
}

void cdrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        cd.volume.right = (u_char)vol;
	sav_cd.right = tmp;

	if(!fl_get_button(cd.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
        	cd.volume.left = cd.volume.right;
                fl_set_slider_value(cd.obj.left,1.0 - tmp);
		sav_cd.left = tmp;

	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);
    }
    old_vol = vol;
}


void lockdspCB(FL_OBJECT *ob, long data)
{

}

void dspleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	dsp.volume.left = (u_char)vol;
	sav_dsp.left = tmp;

	if(!fl_get_button(dsp.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	dsp.volume.right =  dsp.volume.left;
		fl_set_slider_value(dsp.obj.right,1.0 - tmp);	
		sav_dsp.right = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);

    }
    old_vol = vol;
}

void dsprightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	dsp.volume.right = (u_char)vol;
	sav_dsp.right = tmp;

	if(!fl_get_button(dsp.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	dsp.volume.left =  dsp.volume.right;
		fl_set_slider_value(dsp.obj.left,1.0 - tmp);	
		sav_dsp.left = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);
    }
    old_vol = vol;
}

void lockfmCB(FL_OBJECT *ob, long data)
{

}

void fmleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	fm.volume.left = (u_char)vol;
	sav_fm.left = tmp;

	if(!fl_get_button(fm.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	fm.volume.right =  fm.volume.left;
		fl_set_slider_value(fm.obj.right,1.0 - tmp);	
		sav_fm.right = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
    }
    old_vol = vol;
}

void fmrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	fm.volume.right = (u_char)vol;
	sav_fm.right = tmp;

	if(!fl_get_button(fm.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	fm.volume.left =  fm.volume.right;
		fl_set_slider_value(fm.obj.left,1.0 - tmp);	
		sav_fm.left = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
    }
    old_vol = vol;
}

void locklineCB(FL_OBJECT *ob, long data)
{

}

void lineleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        line.volume.left = (u_char)vol;
	sav_line.left = tmp;

        if(!fl_get_button(line.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                line.volume.right =  line.volume.left;
                fl_set_slider_value(line.obj.right,1.0 - tmp);
		sav_line.right = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
    }
    old_vol = vol;

}

void linerightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        line.volume.right = (u_char)vol;
	sav_line.right = tmp;

        if(!fl_get_button(line.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                line.volume.left =  line.volume.right;
                fl_set_slider_value(line.obj.left,1.0 - tmp);
		sav_line.left = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
    }
    old_vol = vol;

}

void lockmicCB(FL_OBJECT *ob, long data)
{

}

void micleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	mic.volume.left = (u_char)vol;
	sav_mic.left = tmp;

	if(!fl_get_button(mic.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	mic.volume.right =  mic.volume.left;
		fl_set_slider_value(mic.obj.right,1.0 - tmp);	
		sav_mic.right = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
    }
    old_vol = vol;
}

void micrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	mic.volume.right = (u_char)vol;
	sav_mic.right = tmp;

	if(!fl_get_button(mic.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	mic.volume.left =  mic.volume.right;
		fl_set_slider_value(mic.obj.left,1.0 - tmp);	
		sav_mic.left = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
    }
    old_vol = vol;
}

void lockrecordCB(FL_OBJECT *ob, long data)
{

}

void recordleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	record.volume.left = (u_char)vol;
	sav_record.left = tmp;

	if(!fl_get_button(record.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	record.volume.right =  record.volume.left;
		fl_set_slider_value(record.obj.right,1.0 - tmp);	
		sav_record.right = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_RECLEV), &record.volume);
    }
    old_vol = vol;
}

void recordrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

	record.volume.right = (u_char)vol;
	sav_record.right = tmp;

	if(!fl_get_button(record.toggle.lock.obj)) {
		/* now set the other slider & value to match this one */
        	record.volume.left =  record.volume.right;
		fl_set_slider_value(record.obj.left,1.0 - tmp);	
		sav_record.left = tmp;
	}

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_RECLEV), &record.volume);
    }
    old_vol = vol;
}

void lockbassCB(FL_OBJECT *ob, long data)
{

}

void bassleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        bass.volume.left = (u_char)vol;
        sav_bass.left = tmp;

        if(!fl_get_button(bass.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                bass.volume.right =  bass.volume.left;
                fl_set_slider_value(bass.obj.right,1.0 - tmp);
                sav_bass.right = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass.volume);
    }
    old_vol = vol;

}

void bassrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        bass.volume.right = (u_char)vol;
        sav_bass.right = tmp;

        if(!fl_get_button(bass.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                bass.volume.left =  bass.volume.right;
                fl_set_slider_value(bass.obj.left,1.0 - tmp);
                sav_bass.left = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass.volume);
    }
    old_vol = vol;

}

void locktrebleCB(FL_OBJECT *ob, long data)
{

}

void trebleleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        treble.volume.left = (u_char)vol;
        sav_treble.left = tmp;

        if(!fl_get_button(treble.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                treble.volume.right =  treble.volume.left;
                fl_set_slider_value(treble.obj.right,1.0 - tmp);
                sav_treble.right = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble.volume);
    }
    old_vol = vol;

}

void treblerightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        treble.volume.right = (u_char)vol;
        sav_treble.right = tmp;

        if(!fl_get_button(treble.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                treble.volume.left =  treble.volume.right;
                fl_set_slider_value(treble.obj.left,1.0 - tmp);
                sav_treble.left = tmp;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble.volume);
    }
    old_vol = vol;

}

void lockmasterCB(FL_OBJECT *ob, long data)
{

}

void masterleftvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        master.volume.left = (u_char)vol;
	sav_master.left = tmp;

        if(!fl_get_button(master.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                master.volume.right =  master.volume.left;
                fl_set_slider_value(master.obj.right,1.0 - tmp);
		sav_master.right = sav_master.left;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);
    }
    old_vol = vol;

}

void masterrightvolCB(FL_OBJECT *ob, long data)
{
    static double               vol,tmp;
    static double               old_vol = 0.0;

    tmp = 1.0 - fl_get_slider_value(ob);
    if (tmp != old_vol)
    {
        vol = tmp*SOUND_FULL_SCALE;

        master.volume.right = (u_char)vol;
	sav_master.right = tmp;

        if(!fl_get_button(master.toggle.lock.obj)) {
                /* now set the other slider & value to match this one */
                master.volume.left =  master.volume.right;
                fl_set_slider_value(master.obj.left,1.0 - tmp);
		sav_master.left = sav_master.right;
        }

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);
    }
    old_vol = vol;

}

void bassnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;
        bass.volume.left = (u_char)vol;

        fl_set_slider_value(bass.obj.left,0.50);

        bass.volume.right = (u_char)vol;

        fl_set_slider_value(bass.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass.volume);
}

void bassmaxCB(FL_OBJECT *ob, long data)
{
	sav_bass.left  = 1.0 - fl_get_slider_value(bass.obj.left);
	sav_bass.right = 1.0 - fl_get_slider_value(bass.obj.right);

	bass.volume.left = bass.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(bass.obj.left,0.0);
	fl_set_slider_value(bass.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass.volume);
}

void bassminCB(FL_OBJECT *ob, long data)
{
        sav_bass.left  = 1.0 - fl_get_slider_value(bass.obj.left);
        sav_bass.right = 1.0 - fl_get_slider_value(bass.obj.right);

        bass.volume.left = bass.volume.right = 0.0;
        fl_set_slider_value(bass.obj.left,1.0);
        fl_set_slider_value(bass.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass.volume);
}

void treblenormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;
        treble.volume.left = (u_char)vol;

        fl_set_slider_value(treble.obj.left,0.50);

        treble.volume.right = (u_char)vol;

        fl_set_slider_value(treble.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble.volume);
}

void treblemaxCB(FL_OBJECT *ob, long data)
{
	sav_treble.left  = 1.0 - fl_get_slider_value(treble.obj.left);
	sav_treble.right = 1.0 - fl_get_slider_value(treble.obj.right);

	treble.volume.left = treble.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(treble.obj.left,0.0);
	fl_set_slider_value(treble.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble.volume);

}

void trebleminCB(FL_OBJECT *ob, long data)
{
        sav_treble.left  = 1.0 - fl_get_slider_value(treble.obj.left);
        sav_treble.right = 1.0 - fl_get_slider_value(treble.obj.right);

        treble.volume.left = treble.volume.right = 0.0;
        fl_set_slider_value(treble.obj.left,1.0);
        fl_set_slider_value(treble.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble.volume);
}

void cdnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        cd.volume.left = (u_char)vol;
        fl_set_slider_value(cd.obj.left,0.50);

        cd.volume.right = (u_char)vol;
        fl_set_slider_value(cd.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);
}

void cdmaxCB(FL_OBJECT *ob, long data)
{

	sav_cd.left  = 1.0 - fl_get_slider_value(cd.obj.left);
	sav_cd.right = 1.0 - fl_get_slider_value(cd.obj.right);

	cd.volume.left = cd.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(cd.obj.left,0.0);
	fl_set_slider_value(cd.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);
}

void cdmuteCB(FL_OBJECT *ob, long data)
{
        sav_cd.left  = 1.0 - fl_get_slider_value(cd.obj.left);
        sav_cd.right = 1.0 - fl_get_slider_value(cd.obj.right);

        cd.volume.left = cd.volume.right = 0.0;
        fl_set_slider_value(cd.obj.left,1.0);
        fl_set_slider_value(cd.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);

}

void dspnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        dsp.volume.left = (u_char)vol;
        fl_set_slider_value(dsp.obj.left,0.50);

        dsp.volume.right = (u_char)vol;
        fl_set_slider_value(dsp.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);
}

void dspmaxCB(FL_OBJECT *ob, long data)
{
	sav_dsp.left  = 1.0 - fl_get_slider_value(dsp.obj.left);
	sav_dsp.right = 1.0 - fl_get_slider_value(dsp.obj.right);

	dsp.volume.left = dsp.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(dsp.obj.left,0.0);
	fl_set_slider_value(dsp.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);
}

void dspmuteCB(FL_OBJECT *ob, long data)
{
        sav_dsp.left  = 1.0 - fl_get_slider_value(dsp.obj.left);
        sav_dsp.right = 1.0 - fl_get_slider_value(dsp.obj.right);

        dsp.volume.left = dsp.volume.right = 0.0;
        fl_set_slider_value(dsp.obj.left,1.0);
        fl_set_slider_value(dsp.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);
}

void fmnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        fm.volume.left = (u_char)vol;
        fl_set_slider_value(fm.obj.left,0.50);

        fm.volume.right = (u_char)vol;
        fl_set_slider_value(fm.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
}

void fmmaxCB(FL_OBJECT *ob, long data)
{
	sav_fm.left  = 1.0 - fl_get_slider_value(fm.obj.left);
	sav_fm.right = 1.0 - fl_get_slider_value(fm.obj.right);

	fm.volume.left = fm.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(fm.obj.left,0.0);
	fl_set_slider_value(fm.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
}

void fmmuteCB(FL_OBJECT *ob, long data)
{
        sav_fm.left  = 1.0 - fl_get_slider_value(fm.obj.left);
        sav_fm.right = 1.0 - fl_get_slider_value(fm.obj.right);

        fm.volume.left = fm.volume.right = 0.0;
        fl_set_slider_value(fm.obj.left,1.0);
        fl_set_slider_value(fm.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
}

void linenormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        line.volume.left = (u_char)vol;
        fl_set_slider_value(line.obj.left,0.50);

        line.volume.right = (u_char)vol;
        fl_set_slider_value(line.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
}

void linemaxCB(FL_OBJECT *ob, long data)
{
	sav_line.left  = 1.0 - fl_get_slider_value(line.obj.left);
	sav_line.right = 1.0 - fl_get_slider_value(line.obj.right);

	line.volume.left = line.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(line.obj.left,0.0);
	fl_set_slider_value(line.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
}

void linemuteCB(FL_OBJECT *ob, long data)
{
        sav_line.left  = 1.0 - fl_get_slider_value(line.obj.left);
        sav_line.right = 1.0 - fl_get_slider_value(line.obj.right);

        line.volume.left = line.volume.right = 0.0;
        fl_set_slider_value(line.obj.left,1.0);
        fl_set_slider_value(line.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
}

void micnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        mic.volume.left = (u_char)vol;
        fl_set_slider_value(mic.obj.left,0.50);

        mic.volume.right = (u_char)vol;
        fl_set_slider_value(mic.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
}

void micmaxCB(FL_OBJECT *ob, long data)
{
	sav_mic.left  = 1.0 - fl_get_slider_value(mic.obj.left);
	sav_mic.right = 1.0 - fl_get_slider_value(mic.obj.right);

	mic.volume.left = mic.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(mic.obj.left,0.0);
	fl_set_slider_value(mic.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
}

void micmuteCB(FL_OBJECT *ob, long data)
{
        sav_mic.left  = 1.0 - fl_get_slider_value(mic.obj.left);
        sav_mic.right = 1.0 - fl_get_slider_value(mic.obj.right);

        mic.volume.left = mic.volume.right = 0.0;
        fl_set_slider_value(mic.obj.left,1.0);
        fl_set_slider_value(mic.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
}

void recordnormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        record.volume.left = (u_char)vol;
        fl_set_slider_value(record.obj.left,0.50);

        record.volume.right = (u_char)vol;
        fl_set_slider_value(record.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_RECLEV), &record.volume);
}

void recordmaxCB(FL_OBJECT *ob, long data)
{
	sav_record.left  = 1.0 - fl_get_slider_value(record.obj.left);
	sav_record.right = 1.0 - fl_get_slider_value(record.obj.right);

	record.volume.left = record.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(record.obj.left,0.0);
	fl_set_slider_value(record.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_RECLEV), &record.volume);
}

void recordmuteCB(FL_OBJECT *ob, long data)
{
        sav_record.left  = 1.0 - fl_get_slider_value(record.obj.left);
        sav_record.right = 1.0 - fl_get_slider_value(record.obj.right);

        record.volume.left = record.volume.right = 0.0;
        fl_set_slider_value(record.obj.left,1.0);
        fl_set_slider_value(record.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_RECLEV), &record.volume);
}


/* setting up the record source not implemented yet */

void cdrecCB(FL_OBJECT *ob, long data)
{

}

void dsprecCB(FL_OBJECT *ob, long data)
{

}

void fmrecCB(FL_OBJECT *ob, long data)
{

}

void linerecCB(FL_OBJECT *ob, long data)
{

}

void micrecCB(FL_OBJECT *ob, long data)
{

}

void recordonoffCB(FL_OBJECT *ob, long data)
{

}

void masternormCB(FL_OBJECT *ob, long data)
{
    static double               vol;

	vol = 0.5*SOUND_FULL_SCALE;

        master.volume.left = (u_char)vol;
        fl_set_slider_value(master.obj.left,0.50);

        master.volume.right = (u_char)vol;
        fl_set_slider_value(master.obj.right,0.50);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);
}

void mastermaxCB(FL_OBJECT *ob, long data)
{
	sav_master.left  = 1.0 - fl_get_slider_value(master.obj.left);
	sav_master.right = 1.0 - fl_get_slider_value(master.obj.right);

	master.volume.left = master.volume.right = SOUND_FULL_SCALE;
	fl_set_slider_value(master.obj.left,0.0);
	fl_set_slider_value(master.obj.right,0.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);
}

void mastermuteCB(FL_OBJECT *ob, long data)
{
        sav_master.left  = 1.0 - fl_get_slider_value(master.obj.left);
        sav_master.right = 1.0 - fl_get_slider_value(master.obj.right);

        master.volume.left = master.volume.right = 0.0;
        fl_set_slider_value(master.obj.left,1.0);
        fl_set_slider_value(master.obj.right,1.0);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);
}

void write_channels(){

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd.volume);
        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &fm.volume);
        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dsp.volume);
        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &line.volume);
        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &mic.volume);
}

void cdsoloCB(FL_OBJECT *ob, long data)
{
	static	int	flip;
	StereoVolume	dummy;

	if(!flip) {
		flip = 1;
		write_channels();
	}
	if (fl_get_button(ob)) {
        	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &dummy);
        	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dummy);
        	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &dummy);
        	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &dummy);
		flip = 0;
	}
}

void dspsoloCB(FL_OBJECT *ob, long data)
{
        static  int     flip;
        StereoVolume    dummy;

        if(!flip) {
                flip = 1;
                write_channels();
        }
        if (fl_get_button(ob)) {
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &dummy);
                flip = 0;
        }

}

void fmsoloCB(FL_OBJECT *ob, long data)
{
        static  int     flip;
        StereoVolume    dummy;

        if(!flip) {
                flip = 1;
                write_channels();
        }
        if (fl_get_button(ob)) {
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &dummy);
                flip = 0;
        }

}

void linesoloCB(FL_OBJECT *ob, long data)
{
        static  int     flip;
        StereoVolume    dummy;

        if(!flip) {
                flip = 1;
                write_channels();
        }
        if (fl_get_button(ob)) {
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &dummy);
                flip = 0;
        }

}

void micsoloCB(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
        static  int     flip;
        StereoVolume    dummy;

        if(!flip) {
                flip = 1;
                write_channels();
        }
        if (fl_get_button(ob)) {
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &dummy);
                ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &dummy);
                flip = 0;
        }

}

void balanceCB(FL_OBJECT *ob, long data)
{
    /* balance slider routine */
    double		vol, Lsbal, Rsbal, Lmax_shift, Rmax_shift;
    double		shift, tmpL, tmpR;
    int			sign = 1;

	/* get the position of the balance slider */
	Lsbal = 1.0 - fl_get_slider_value(ob);

	shift = Lsbal - Sbalance.left;

	Rsbal = 1.0 - Lsbal;

        tmpL = 1.0 - fl_get_slider_value(master.obj.left);
	Lmax_shift = tmpL + shift;
	if ( Lmax_shift< 0.0 ) Lmax_shift = 0.0;
	if (Lmax_shift > 1.0 ) Lmax_shift = 1.0;

        tmpR = 1.0 - fl_get_slider_value(master.obj.right);
        Rmax_shift = tmpR - shift;
        if ( Rmax_shift< 0.0 ) Rmax_shift = 0.0;
        if (Rmax_shift > 1.0 ) Rmax_shift = 1.0;

	vol = Lmax_shift*SOUND_FULL_SCALE;
        master.volume.left = (u_char)vol;
        fl_set_slider_value(master.obj.left,1.0 - Lmax_shift);

        vol = Rmax_shift*SOUND_FULL_SCALE;
        master.volume.right = (u_char)vol;
        fl_set_slider_value(master.obj.right,1.0 - Rmax_shift);

        ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &master.volume);

	/* save for next call */
	Sbalance.left = Lsbal;
	Sbalance.right = Rsbal;
}

void quitCB(FL_OBJECT *ob, long data)
{
	/* caller wants to exit program */
	  exit (0);
}

/*---------------------------------------*/
